1
0

install.sh 7.3 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175
  1. #!/bin/bash
  2. red='\033[0;31m'
  3. green='\033[0;32m'
  4. yellow='\033[0;33m'
  5. plain='\033[0m'
  6. cur_dir=$(pwd)
  7. # check root
  8. [[ $EUID -ne 0 ]] && echo -e "${red}Fatal error:${plain} Please run this script with root privilege \n " && exit 1
  9. # Check OS and set release variable
  10. if [[ -f /etc/os-release ]]; then
  11. source /etc/os-release
  12. release=$ID
  13. elif [[ -f /usr/lib/os-release ]]; then
  14. source /usr/lib/os-release
  15. release=$ID
  16. else
  17. echo "Failed to check the system OS, please contact the author!" >&2
  18. exit 1
  19. fi
  20. echo "The OS release is: $release"
  21. arch3xui() {
  22. case "$(uname -m)" in
  23. x86_64 | x64 | amd64 ) echo 'amd64' ;;
  24. armv8 | arm64 | aarch64 ) echo 'arm64' ;;
  25. * ) echo -e "${green}Unsupported CPU architecture! ${plain}" && rm -f install.sh && exit 1 ;;
  26. esac
  27. }
  28. echo "arch: $(arch3xui)"
  29. os_version=""
  30. os_version=$(grep -i version_id /etc/os-release | cut -d \" -f2 | cut -d . -f1)
  31. if [[ "${release}" == "centos" ]]; then
  32. if [[ ${os_version} -lt 8 ]]; then
  33. echo -e "${red} Please use CentOS 8 or higher ${plain}\n" && exit 1
  34. fi
  35. elif [[ "${release}" == "ubuntu" ]]; then
  36. if [[ ${os_version} -lt 20 ]]; then
  37. echo -e "${red}please use Ubuntu 20 or higher version!${plain}\n" && exit 1
  38. fi
  39. elif [[ "${release}" == "fedora" ]]; then
  40. if [[ ${os_version} -lt 36 ]]; then
  41. echo -e "${red}please use Fedora 36 or higher version!${plain}\n" && exit 1
  42. fi
  43. elif [[ "${release}" == "debian" ]]; then
  44. if [[ ${os_version} -lt 10 ]]; then
  45. echo -e "${red} Please use Debian 10 or higher ${plain}\n" && exit 1
  46. fi
  47. else
  48. echo -e "${red}Failed to check the OS version, please contact the author!${plain}" && exit 1
  49. fi
  50. install_base() {
  51. case "${release}" in
  52. centos|fedora)
  53. yum install -y -q wget curl tar
  54. ;;
  55. *)
  56. apt install -y -q wget curl tar
  57. ;;
  58. esac
  59. }
  60. #This function will be called when user installed x-ui out of sercurity
  61. config_after_install() {
  62. /usr/local/x-ui/x-ui migrate
  63. echo -e "${yellow}Install/update finished! For security it's recommended to modify panel settings ${plain}"
  64. read -p "Do you want to continue with the modification [y/n]? ": config_confirm
  65. if [[ x"${config_confirm}" == x"y" || x"${config_confirm}" == x"Y" ]]; then
  66. read -p "Please set up your username:" config_account
  67. echo -e "${yellow}Your username will be:${config_account}${plain}"
  68. read -p "Please set up your password:" config_password
  69. echo -e "${yellow}Your password will be:${config_password}${plain}"
  70. read -p "Please set up the panel port:" config_port
  71. echo -e "${yellow}Your panel port is:${config_port}${plain}"
  72. echo -e "${yellow}Initializing, please wait...${plain}"
  73. /usr/local/x-ui/x-ui setting -username ${config_account} -password ${config_password}
  74. echo -e "${yellow}Account name and password set successfully!${plain}"
  75. /usr/local/x-ui/x-ui setting -port ${config_port}
  76. echo -e "${yellow}Panel port set successfully!${plain}"
  77. else
  78. echo -e "${red}cancel...${plain}"
  79. if [[ ! -f "/etc/x-ui/x-ui.db" ]]; then
  80. local usernameTemp=$(head -c 6 /dev/urandom | base64)
  81. local passwordTemp=$(head -c 6 /dev/urandom | base64)
  82. /usr/local/x-ui/x-ui setting -username ${usernameTemp} -password ${passwordTemp}
  83. echo -e "this is a fresh installation,will generate random login info for security concerns:"
  84. echo -e "###############################################"
  85. echo -e "${green}username:${usernameTemp}${plain}"
  86. echo -e "${green}password:${passwordTemp}${plain}"
  87. echo -e "###############################################"
  88. echo -e "${red}if you forgot your login info,you can type x-ui and then type 7 to check after installation${plain}"
  89. else
  90. echo -e "${red} this is your upgrade,will keep old settings,if you forgot your login info,you can type x-ui and then type 7 to check${plain}"
  91. fi
  92. fi
  93. }
  94. install_x-ui() {
  95. systemctl stop x-ui
  96. cd /usr/local/
  97. if [ $# == 0 ]; then
  98. last_version=$(curl -Ls "https://api.github.com/repos/MHSanaei/3x-ui/releases/latest" | grep '"tag_name":' | sed -E 's/.*"([^"]+)".*/\1/')
  99. if [[ ! -n "$last_version" ]]; then
  100. echo -e "${red}Failed to fetch x-ui version, it maybe due to Github API restrictions, please try it later${plain}"
  101. exit 1
  102. fi
  103. echo -e "Got x-ui latest version: ${last_version}, beginning the installation..."
  104. wget -N --no-check-certificate -O /usr/local/x-ui-linux-$(arch3xui).tar.gz https://github.com/MHSanaei/3x-ui/releases/download/${last_version}/x-ui-linux-$(arch3xui).tar.gz
  105. if [[ $? -ne 0 ]]; then
  106. echo -e "${red}Downloading x-ui failed, please be sure that your server can access Github ${plain}"
  107. exit 1
  108. fi
  109. else
  110. last_version=$1
  111. url="https://github.com/MHSanaei/3x-ui/releases/download/${last_version}/x-ui-linux-$(arch3xui).tar.gz"
  112. echo -e "Begining to install x-ui $1"
  113. wget -N --no-check-certificate -O /usr/local/x-ui-linux-$(arch3xui).tar.gz ${url}
  114. if [[ $? -ne 0 ]]; then
  115. echo -e "${red}Download x-ui $1 failed,please check the version exists ${plain}"
  116. exit 1
  117. fi
  118. fi
  119. if [[ -e /usr/local/x-ui/ ]]; then
  120. rm /usr/local/x-ui/ -rf
  121. fi
  122. tar zxvf x-ui-linux-$(arch3xui).tar.gz
  123. rm x-ui-linux-$(arch3xui).tar.gz -f
  124. cd x-ui
  125. chmod +x x-ui bin/xray-linux-$(arch3xui)
  126. cp -f x-ui.service /etc/systemd/system/
  127. wget --no-check-certificate -O /usr/bin/x-ui https://raw.githubusercontent.com/MHSanaei/3x-ui/main/x-ui.sh
  128. chmod +x /usr/local/x-ui/x-ui.sh
  129. chmod +x /usr/bin/x-ui
  130. config_after_install
  131. #echo -e "If it is a new installation, the default web port is ${green}2053${plain}, The username and password are ${green}admin${plain} by default"
  132. #echo -e "Please make sure that this port is not occupied by other procedures,${yellow} And make sure that port 2053 has been released${plain}"
  133. # echo -e "If you want to modify the 2053 to other ports and enter the x-ui command to modify it, you must also ensure that the port you modify is also released"
  134. #echo -e ""
  135. #echo -e "If it is updated panel, access the panel in your previous way"
  136. #echo -e ""
  137. systemctl daemon-reload
  138. systemctl enable x-ui
  139. systemctl start x-ui
  140. echo -e "${green}x-ui ${last_version}${plain} installation finished, it is running now..."
  141. echo -e ""
  142. echo -e "x-ui control menu usages: "
  143. echo -e "----------------------------------------------"
  144. echo -e "x-ui - Enter Admin menu"
  145. echo -e "x-ui start - Start x-ui"
  146. echo -e "x-ui stop - Stop x-ui"
  147. echo -e "x-ui restart - Restart x-ui"
  148. echo -e "x-ui status - Show x-ui status"
  149. echo -e "x-ui enable - Enable x-ui on system startup"
  150. echo -e "x-ui disable - Disable x-ui on system startup"
  151. echo -e "x-ui log - Check x-ui logs"
  152. echo -e "x-ui update - Update x-ui"
  153. echo -e "x-ui install - Install x-ui"
  154. echo -e "x-ui uninstall - Uninstall x-ui"
  155. echo -e "----------------------------------------------"
  156. }
  157. echo -e "${green}Running...${plain}"
  158. install_base
  159. install_x-ui $1